﻿Imports C1.Chart
Imports C1.Win.Chart

Public Class Form1

    Dim minVal As Integer = Integer.MaxValue
    Dim maxVal As Integer = Integer.MinValue

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        FlexChart1.DataSource = GetProductRevenue()
        ' Configuring FlexChart
        FlexChart1.Series.Clear()
        ' Selecting chart's type
        FlexChart1.ChartType = C1.Chart.ChartType.Column
        ' Setting the content and position of data labels in the FlexChart
        FlexChart1.DataLabel.Content = "{y}"
        FlexChart1.DataLabel.Position = LabelPosition.Top
        ' Setting chart's Header and styling it
        FlexChart1.Header.Content = "DateWise Revenue"
        ' Adding a Series to chart and binding it (AxisY) to 'Revenue' field of DataCollection
        FlexChart1.Series.Add(New C1.Win.Chart.Series With {
    .Name = "Sales",
    .Binding = "Revenue"
})
        'Binding chart's AxisX to 'Date' so Dates are shown in Horizontal axis
        FlexChart1.BindingX = "OrderDate"
        FlexChart1.AxisY.Max = 10000

        AddHandler FlexChart1.LabelRendering, AddressOf FlexChart1_LabelRendering
        AddHandler FlexChart1.Rendering, AddressOf FlexChart_Rendering
    End Sub

    Private Sub FlexChart_Rendering(sender As Object, e As RenderEventArgs)
        If TypeOf sender Is FlexChart Then
            Dim flexChart As FlexChart = DirectCast(sender, FlexChart)

            If TypeOf flexChart.DataSource Is List(Of Product) Then
                Dim source As List(Of Product) = DirectCast(flexChart.DataSource, List(Of Product))

                maxVal = source.Max(Function(product) product.Revenue)
                minVal = source.Min(Function(product) product.Revenue)
            End If
        End If
    End Sub

    Private Sub FlexChart1_LabelRendering(sender As Object, e As RenderDataLabelEventArgs)

        If e.Text = minVal.ToString() Then
            Dim s As SizeF = e.Graphics.MeasureString(e.Text, FlexChart1.Font)
            Dim rectangle As New Rectangle(New Point(CInt(e.Point.X), CInt(e.Point.Y)), New Size(CInt(s.Width), CInt(s.Height)))
            e.Graphics.DrawRectangle(New Pen(Color.Red), rectangle)
        End If

        If e.Text = maxVal.ToString() Then
            Dim s As SizeF = e.Graphics.MeasureString(e.Text, FlexChart1.Font)
            Dim rectangle As New Rectangle(New Point(CInt(e.Point.X), CInt(e.Point.Y)), New Size(CInt(s.Width), CInt(s.Height)))
            e.Graphics.DrawRectangle(New Pen(Color.Green), rectangle)
        End If
    End Sub

    Public Function GetProductRevenue() As List(Of Product)
        Dim _list As New List(Of Product)
        _list.Add(New Product With {.Name = "Desktop", .OrderDate = New DateTime(2018, 4, 7), .Orders = 265, .Revenue = 6625})
        _list.Add(New Product With {.Name = "Desktop", .OrderDate = New DateTime(2018, 5, 8), .Orders = 107, .Revenue = 2675})
        _list.Add(New Product With {.Name = "Mouse", .OrderDate = New DateTime(2018, 6, 2), .Orders = 56, .Revenue = 560})
        _list.Add(New Product With {.Name = "Mouse", .OrderDate = New DateTime(2018, 7, 6), .Orders = 572, .Revenue = 5720})
        _list.Add(New Product With {.Name = "Mouse", .OrderDate = New DateTime(2018, 8, 5), .Orders = 468, .Revenue = 4680})
        _list.Add(New Product With {.Name = "Printer", .OrderDate = New DateTime(2018, 9, 2), .Orders = 154, .Revenue = 2310})
        _list.Add(New Product With {.Name = "Desktop", .OrderDate = New DateTime(2018, 10, 3), .Orders = 89, .Revenue = 2225})
        _list.Add(New Product With {.Name = "Desktop", .OrderDate = New DateTime(2018, 11, 5), .Orders = 347, .Revenue = 8675})
        _list.Add(New Product With {.Name = "Printer", .OrderDate = New DateTime(2018, 12, 7), .Orders = 204, .Revenue = 3060})
        _list.Add(New Product With {.Name = "Printer", .OrderDate = New DateTime(2019, 1, 3), .Orders = 34, .Revenue = 510})
        _list.Add(New Product With {.Name = "Mouse", .OrderDate = New DateTime(2019, 2, 6), .Orders = 223, .Revenue = 2230})
        _list.Add(New Product With {.Name = "Desktop", .OrderDate = New DateTime(2019, 3, 8), .Orders = 119, .Revenue = 2975})
        Return _list
    End Function


End Class

Public Class Product
    Public Property Name As String
    Public Property OrderDate As DateTime
    Public Property Orders As Integer
    Public Property Revenue As Integer
End Class